using System;
using System.IO;

namespace hegylancok
{
    class Hegylanc
    {
        private byte[] hm;
        private string hexLánc
        {
            get
            {
                string tmp = "";
                foreach (var i in hm)
                {
                    tmp += $"{i:X}";
                }
                return tmp;
            }
        }
        public Hegylanc() //2.
        {
            hm = new byte[80]; //2.a
            Random r = new Random();
            for (int i = 3; i < hm.Length-3; i++) //2.b
            {
                hm[i] = (byte)r.Next(1, 16); //2.c
                if (hm[i] % 2 == 0) hm[i] = 0; //2.d
            }
        }

        public int HegyekSzáma
        {
            get
            {
                int hegyekSzáma = 0;
                string[] m = hexLánc.Split('0');
                foreach (var i in m)
                {
                    if (i.Length == 1) hegyekSzáma++;
                }
                return hegyekSzáma;
            }
        }
        public void Kiír(int feladatSzáma)
        {
            Console.WriteLine($"{feladatSzáma}. feladat:");
            if (feladatSzáma==4) Console.WriteLine(hexLánc);
            else
            {
                for (int i = 0; i < hm.Length; i++)
                {
                    bool ezHegy = false;
                    try
                    {
                        if (hm[i - 1] == 0 && hm[i] != 0 && hm[i + 1] == 0) ezHegy = true;
                    }
                    catch (Exception) { }
                    Console.BackgroundColor = ezHegy ? ConsoleColor.Green : ConsoleColor.White;
                    Console.Write($"{hm[i]:X}");
                }
                Console.WriteLine();
            }
        }

        public string LeghosszabbHegylánc
        {
            get
            {
                string[] m = hexLánc.Split('0');
                string maxHL = m[0];
                for (int i = 1; i < m.Length; i++)
                {
                    if (m[i].Length > maxHL.Length) maxHL = m[i];
                }
                return maxHL;
            }
        }

        public double LeghosszabbHegyláncÁtlagosMagassága
        {
            get
            {
                int szumMagasság = 0;
                foreach (var i in LeghosszabbHegylánc)
                {
                    szumMagasság += Convert.ToInt32(i.ToString(), 16);
                }
                return (double)szumMagasság / LeghosszabbHegylánc.Length;
            }
        }

        public void FájlbaÍr(string fájlnév)
        {
            File.WriteAllText(fájlnév, hexLánc);
        }
    }

    class hegylancok
    {
        static void Main()
        {
            Hegylanc hegylanc = new Hegylanc();
            hegylanc.Kiír(4);
            Console.WriteLine($"5. feladat: Hegyek száma: {hegylanc.HegyekSzáma} db");
            hegylanc.Kiír(6);
            Console.Write("7. feladat:");
            if (hegylanc.LeghosszabbHegylánc.Length <= 1) Console.WriteLine("Nincs hegylánc a vektorban!");
            else
            {
                Console.WriteLine("Leghosszabb hegylánc hossza: {0} Átlagos magassága: {1:F1}",
                    hegylanc.LeghosszabbHegylánc.Length, hegylanc.LeghosszabbHegyláncÁtlagosMagassága);
            }
            hegylanc.FájlbaÍr("hegylancok.txt");
            Console.ReadKey();
        }
    }
}
